Index: usr.bin/xlint/lint1/tree.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/tree.c,v
retrieving revision 1.7
diff -u -r1.7 tree.c
--- usr.bin/xlint/lint1/tree.c	7 Jul 2004 12:24:00 -0000	1.7
+++ usr.bin/xlint/lint1/tree.c	25 Dec 2006 10:25:25 -0000
@@ -2016,15 +2036,22 @@
 				/* case label affected by conversion */
 				warning(196);
 			} else if (op == FARG) {
-				/* conv. of %s to %s is out of rng., arg #%d */
-				warning(295, tyname(gettyp(ot)), tyname(tp),
-					arg);
+				/* %s arg #%d: conv. of %s to %s is out of rng. */
+				warning(295, funcname(farg->fa_func), arg,
+				    tyname(gettyp(ot)), tyname(tp));
 			} else {
 				/* conversion of %s to %s is out of range */
 				warning(119, tyname(gettyp(ot)), tyname(tp));
 			}
 		} else if (nv->v_quad != v->v_quad) {
-			if (op == ASSIGN && tp->t_isfield) {
+			if ((nt == CHAR || nt == UCHAR || nt == SCHAR) &&
+			    v->v_lspec == CHAR) {
+				/*
+				 * Don't warn when assigning a character
+				 * literal to any kind of character (signed,
+				 * unsigned, or unspecified).
+				 */
+			} else if (op == ASSIGN && tp->t_isfield) {
 				/* precision lost in bit-field assignment */
 				warning(166);
 			} else if (op == INIT && tp->t_isfield) {
@@ -2034,9 +2061,9 @@
 				/* case label affected by conversion */
 				warning(196);
 			} else if (op == FARG) {
-				/* conv. of %s to %s is out of rng., arg #%d */
-				warning(295, tyname(gettyp(ot)), tyname(tp),
-					arg);
+				/* %s arg #%d: conv. of %s to %s is out of rng. */
+				warning(295, funcname(farg->fa_func), arg,
+				    tyname(gettyp(ot)), tyname(tp));
 			} else {
 				/* conversion of %s to %s is out of range */
 				warning(119, tyname(gettyp(ot)), tyname(tp));
@@ -2223,9 +2250,8 @@
 	if (op == POINT) {
 		ln = bldamper(ln, 1);
 	} else if (ln->tn_type->t_tspec != PTR) {
-		if (!tflag || !isityp(ln->tn_type->t_tspec))
-			lerror("bldstr() 4");
-		ln = convert(NOOP, 0, tincref(gettyp(VOID), PTR), ln);
+		lerror("bldstr() 4");
+		ln = convert(NOOP, NULL, tincref(gettyp(VOID), PTR), ln);
 	}
 
 #if PTRDIFF_IS_LONG
@@ -2282,8 +2308,6 @@
 
 	if (!noign && ((t = tn->tn_type->t_tspec) == ARRAY || t == FUNC)) {
 		/* & before array or function: ignored */
-		if (tflag)
-			warning(127);
 		return (tn);
 	}
 
@@ -2322,7 +2346,7 @@
 
 		ctn = plength(ln->tn_type);
 		if (rn->tn_type->t_tspec != ctn->tn_type->t_tspec)
-			rn = convert(NOOP, 0, ctn->tn_type, rn);
+			rn = convert(NOOP, NULL, ctn->tn_type, rn);
 		rn = mktnode(MULT, rn->tn_type, rn, ctn);
 		if (rn->tn_left->tn_op == CON)
 			rn = fold(rn);
@@ -2362,7 +2386,7 @@
 	tnode_t	*ntn;
 
 	if ((t = rn->tn_type->t_tspec) != INT && t != UINT)
-		rn = convert(CVT, 0, gettyp(INT), rn);
+		rn = convert(CVT, NULL, gettyp(INT), rn);
 	ntn = mktnode(op, ln->tn_type, ln, rn);
 	return (ntn);
 }
@@ -2407,13 +2431,13 @@
 		rtp = ln->tn_type;
 	} else if (lt == PTR && isityp(rt)) {
 		if (rt != pdt) {
-			rn = convert(NOOP, 0, gettyp(pdt), rn);
+			rn = convert(NOOP, NULL, gettyp(pdt), rn);
 			rt = pdt;
 		}
 		rtp = ln->tn_type;
 	} else if (rt == PTR && isityp(lt)) {
 		if (lt != pdt) {
-			ln = convert(NOOP, 0, gettyp(pdt), ln);
+			ln = convert(NOOP, NULL, gettyp(pdt), ln);
 			lt = pdt;
 		}
 		rtp = rn->tn_type;
@@ -2432,7 +2456,7 @@
 			lerror("bldcol() 6");
 		/*
 		 * XXX For now we simply take the left type. This is
-		 * probably wrong, if one type contains a functionprototype
+		 * probably wrong, if one type contains a function prototype
 		 * and the other one, at the same place, only an old style
 		 * declaration.
 		 */
@@ -2465,7 +2489,7 @@
 			lerror("bldasgn() 2");
 		ctn = plength(ln->tn_type);
 		if (rn->tn_type->t_tspec != ctn->tn_type->t_tspec)
-			rn = convert(NOOP, 0, ctn->tn_type, rn);
+			rn = convert(NOOP, NULL, ctn->tn_type, rn);
 		rn = mktnode(MULT, rn->tn_type, rn, ctn);
 		if (rn->tn_left->tn_op == CON)
 			rn = fold(rn);
@@ -2488,14 +2512,14 @@
 
 	if (op == SHLASS || op == SHRASS) {
 		if (rt != INT) {
-			rn = convert(NOOP, 0, gettyp(INT), rn);
+			rn = convert(NOOP, NULL, gettyp(INT), rn);
 			rt = INT;
 		}
 	} else {
 		if (op == ASSIGN || lt != PTR) {
 			if (lt != rt ||
 			    (ln->tn_type->t_isfield && rn->tn_op == CON)) {
-				rn = convert(op, 0, ln->tn_type, rn);
+				rn = convert(op, NULL, ln->tn_type, rn);
 				rt = lt;
 			}
 		}
@@ -2507,6 +2531,49 @@
 }
 
 /*
+ * Check for division by zero.  Returns 1 if a division by zero is
+ * present, 0 otherwise.
+ */
+static int
+chkdbz(op_t op, tnode_t *rn)
+{
+	int code;
+
+	switch (op) {
+	case DIV:
+	case DIVASS:
+		code = 139;	/* division by 0 */
+		break;
+	case MOD:
+	case MODASS:
+		code = 140;	/* modular division by 0 */
+		break;
+	default:
+		return 0;
+	}
+
+	/* no way of checking unless right side is a constant */
+	if (rn->tn_op != CON)
+		return 0;
+
+	if (isftyp(rn->tn_type->t_tspec)) {
+		if (rn->tn_val->v_ldbl == 0.0) {
+			/* division by 0 */
+			warning(code);
+			return 1;
+		}
+	} else {
+		if (rn->tn_val->v_quad == 0) {
+			/* division by 0 */
+			warning(code);
+			return 1;
+		}
+	}
+
+	return 0;
+}
+
+/*
  * Get length of type tp->t_subt.
  */
 static tnode_t *
@@ -2575,20 +2642,6 @@
 	return (getinode(st, (quad_t)(elem * elsz / CHAR_BIT)));
 }
 
-#ifdef XXX_BROKEN_GCC
-static int
-quad_t_eq(quad_t x, quad_t y)
-{
-	return (x == y);
-}
-
-static int
-u_quad_t_eq(u_quad_t x, u_quad_t y)
-{
-	return (x == y);
-}
-#endif
-
 /*
  * Do only as much as necessary to compute constant expressions.
  * Called only if the operator allows folding and (both) operands
@@ -2632,18 +2685,14 @@
 			ovfl = 1;
 		break;
 	case DIV:
-		if (sr == 0) {
-			/* division by 0 */
-			error(139);
-			q = utyp ? UQUAD_MAX : QUAD_MAX;
+		if (chkdbz(tn->tn_op, tn->tn_right)) {
+			q = utyp ? 0U: 0;
 		} else {
 			q = utyp ? ul / ur : sl / sr;
 		}
 		break;
 	case MOD:
-		if (sr == 0) {
-			/* modulus by 0 */
-			error(140);
+		if (chkdbz(tn->tn_op, tn->tn_right)) {
 			q = 0;
 		} else {
 			q = utyp ? ul % ur : sl % sr;
@@ -2674,7 +2723,7 @@
 		break;
 	case SHR:
 		/*
-		 * The sign must be explizitly extended because
+		 * The sign must be explicitly extended because
 		 * shifts of signed values are implementation dependent.
 		 */
 		q = ul >> sr;
@@ -2693,11 +2742,7 @@
 		q = utyp ? ul > ur : sl > sr;
 		break;
 	case EQ:
-#ifdef XXX_BROKEN_GCC
-		q = utyp ? u_quad_t_eq(ul, ur) : quad_t_eq(sl, sr);
-#else
 		q = utyp ? ul == ur : sl == sr;
-#endif
 		break;
 	case NE:
 		q = utyp ? ul != ur : sl != sr;
@@ -2731,14 +2776,6 @@
 	return (cn);
 }
 
-#ifdef XXX_BROKEN_GCC
-int
-ldbl_t_neq(ldbl_t x, ldbl_t y)
-{
-	return (x != y);
-}
-#endif
-
 /*
  * Same for operators whose operands are compared with 0 (test context).
  */
@@ -2754,22 +2791,14 @@
 		lerror("foldtst() 1");
 
 	if (isftyp(tn->tn_left->tn_type->t_tspec)) {
-#ifdef XXX_BROKEN_GCC
-		l = ldbl_t_neq(tn->tn_left->tn_val->v_ldbl, 0.0);
-#else
 		l = tn->tn_left->tn_val->v_ldbl != 0.0;
-#endif
 	} else {
 		l = tn->tn_left->tn_val->v_quad != 0;
 	}
 
 	if (modtab[tn->tn_op].m_binary) {
 		if (isftyp(tn->tn_right->tn_type->t_tspec)) {
-#ifdef XXX_BROKEN_GCC
-			r = ldbl_t_neq(tn->tn_right->tn_val->v_ldbl, 0.0);
-#else
 			r = tn->tn_right->tn_val->v_ldbl != 0.0;
-#endif
 		} else {
 			r = tn->tn_right->tn_val->v_quad != 0;
 		}
@@ -2831,9 +2860,7 @@
 		v->v_ldbl = l * r;
 		break;
 	case DIV:
-		if (r == 0.0) {
-			/* division by 0 */
-			error(139);
+		if (chkdbz(tn->tn_op, tn->tn_right)) {
 			if (t == FLOAT) {
 				v->v_ldbl = l < 0 ? -FLT_MAX : FLT_MAX;
 			} else if (t == DOUBLE) {
@@ -2895,6 +2922,26 @@
 }
 
 /*
+ * Create a constant node for sizeof(term).
+ */
+tnode_t *
+bldszoftrm(tnode_t *tn)
+{
+	switch (tn->tn_op) {
+	case POINT:
+	case STAR:
+	case NAME:
+	case STRING:
+		break;
+	default:
+		warning(312, modtab[tn->tn_op].m_name);
+	}
+
+
+	return bldszof(tn->tn_type);
+}
+
+/*
  * Create a constant node for sizeof.
  */
 tnode_t *
@@ -3012,7 +3059,7 @@
 		return (NULL);
 	}
 
-	tn = convert(CVT, 0, tp, tn);
+	tn = convert(CVT, NULL, tp, tn);
 	tn->tn_cast = 1;
 
 	return (tn);
@@ -3060,6 +3107,9 @@
 		fcop = ICALL;
 	}
 
+	if (func->tn_sym->s_noreturn)
+		notreach(0);
+
 	/*
 	 * after cconv() func will always be a pointer to a function
 	 * if it is a valid function designator.
@@ -3073,7 +3123,7 @@
 		return (NULL);
 	}
 
-	args = chkfarg(func->tn_type->t_subt, args);
+	args = chkfarg(func, args);
 
 	ntn = mktnode(fcop, func->tn_type->t_subt->t_subt, func, args);
 
@@ -3083,15 +3133,22 @@
 /*
  * Check types of all function arguments and insert conversions,
  * if necessary.
+ *
+ * func: called function
+ * args: arguments to function
  */
 static tnode_t *
-chkfarg(type_t *ftp, tnode_t *args)
+chkfarg(tnode_t *func, tnode_t *args)
 {
+	type_t	*ftp;
 	tnode_t	*arg;
 	sym_t	*asym;
+	farg_t	farg;
 	tspec_t	at;
 	int	narg, npar, n, i;
 
+	ftp = func->tn_type->t_subt;
+
 	/* get # of args in the prototype */
 	npar = 0;
 	for (asym = ftp->t_args; asym != NULL; asym = asym->s_nxt)
@@ -3117,7 +3174,7 @@
 		 */
 		for (i = narg, arg = args; i > n; i--, arg = arg->tn_right) ;
 
-		/* some things which are always not allowd */
+		/* some things which are never allowed */
 		if ((at = arg->tn_left->tn_type->t_tspec) == VOID) {
 			/* void expressions may not be arguments, arg #%d */
 			error(151, n);
@@ -3135,9 +3192,11 @@
 
 		/* class conversions (arg in value context) */
 		arg->tn_left = cconv(arg->tn_left);
-
+		farg.fa_num = n;
+		farg.fa_sym = asym;
+		farg.fa_func = func;
 		if (asym != NULL) {
-			arg->tn_left = parg(n, asym->s_type, arg->tn_left);
+			arg->tn_left = parg(&farg, arg->tn_left);
 		} else {
 			arg->tn_left = promote(NOOP, 1, arg->tn_left);
 		}
@@ -3155,20 +3214,26 @@
  * prototype parameter. If it is a valid combination, but both types
  * are not the same, insert a conversion to convert the argument into
  * the type of the parameter.
+ *
+ * n:	position of arg
+ * tp:	expected type (from prototype)
+ * tn:	argument
  */
 static tnode_t *
-parg(int n, type_t *tp, tnode_t *tn)
+parg(farg_t *farg, tnode_t *tn)
 {
 	tnode_t	*ln;
+	type_t	*tp;
 	int	warn;
 
+	tp = farg->fa_sym->s_type;
 	ln = xcalloc(1, sizeof (tnode_t));
 	ln->tn_type = tduptyp(tp);
 	ln->tn_type->t_const = 0;
 	ln->tn_lvalue = 1;
-	if (typeok(FARG, n, ln, tn)) {
+	if (typeok(FARG, farg, ln, tn)) {
 		if (!eqtype(tp, tn->tn_type, 1, 0, (warn = 0, &warn)) || warn)
-			tn = convert(FARG, n, tp, tn);
+			tn = convert(FARG, farg, tp, tn);
 	}
 	free(ln);
 	return (tn);
@@ -3248,13 +3313,18 @@
 
 	chkmisc(tn, vctx, tctx, !tctx, 0, 0, 0);
 	if (tn->tn_op == ASSIGN) {
-		if (hflag && tctx)
+		if (hflag && tctx && !tn->tn_parn)
 			/* assignment in conditional context */
 			warning(159);
 	} else if (tn->tn_op == CON) {
-		if (hflag && tctx && !ccflg)
-			/* constant in conditional context */
-			warning(161);
+		if (hflag && tctx && !ccflg) {
+			if (!isityp(tn->tn_type->t_tspec) ||
+			    (tn->tn_val->v_quad != 0 &&
+			    tn->tn_val->v_quad != 1)) {
+				/* constant in conditional context */
+				warning(161);
+			}
+		}
 	}
 	if (!modtab[tn->tn_op].m_sideeff) {
 		/*
@@ -3276,48 +3346,58 @@
 {
 	if (!hflag)
 		return;
-
-	while (!modtab[tn->tn_op].m_sideeff) {
-		if (tn->tn_op == CVT && tn->tn_type->t_tspec == VOID) {
-			tn = tn->tn_left;
-		} else if (tn->tn_op == LOGAND || tn->tn_op == LOGOR) {
-			/*
-			 * && and || have a side effect if the right operand
-			 * has a side effect.
-			 */
-			tn = tn->tn_right;
-		} else if (tn->tn_op == QUEST) {
-			/*
-			 * ? has a side effect if at least one of its right
-			 * operands has a side effect
-			 */
-			tn = tn->tn_right;
-		} else if (tn->tn_op == COLON) {
-			/*
-			 * : has a side effect if at least one of its operands
-			 * has a side effect
-			 */
-			if (modtab[tn->tn_left->tn_op].m_sideeff) {
-				tn = tn->tn_left;
-			} else if (modtab[tn->tn_right->tn_op].m_sideeff) {
-				tn = tn->tn_right;
-			} else {
-				break;
-			}
-		} else {
-			break;
-		}
-	}
-	if (!modtab[tn->tn_op].m_sideeff)
+	if (nulleffexpr(tn)) {
 		/* expression has null effect */
 		warning(129);
+	}
+}
+
+static int
+nulleffexpr(tnode_t *tn)
+{
+	int r1, r2;
+
+	if (modtab[tn->tn_op].m_sideeff)
+		return (0);
+
+	switch (tn->tn_op) {
+	case CVT:
+		if (tn->tn_type->t_tspec == VOID)
+			return (0);
+		else
+			return (nulleffexpr(tn->tn_left));
+	case LOGAND:
+	case LOGOR:
+		/*
+		 * && and || have a null effect if the right operand
+		 * has null effect.
+		 */
+		return (nulleffexpr(tn->tn_right));
+	case QUEST:
+		/*
+		 * ? has null effect if both of its right * operands
+		 * have null effect
+		 */
+		return (nulleffexpr(tn->tn_right));
+	case COLON:
+	case COMMA:
+		/*
+		 * : and , have null effect if both of the operands have
+		 * null effect
+		 */
+		r1 = nulleffexpr(tn->tn_left);
+		r2 = nulleffexpr(tn->tn_right);
+		return (r1 && r2);
+	default:
+		return (1);
+	}
 }
 
 /*
  * Dump an expression to stdout
  * only used for debugging
  */
-static void
+void
 displexpr(tnode_t *tn, int offs)
 {
 	u_quad_t uq;
@@ -3375,7 +3455,7 @@
 /* ARGSUSED */
 void
 chkmisc(tnode_t *tn, int vctx, int tctx, int eqwarn, int fcall, int rvdisc,
-	int szof)
+    int szof)
 {
 	tnode_t	*ln, *rn;
 	mod_t	*mp;
@@ -3425,7 +3505,7 @@
 		if (ln->tn_op == NAME && (reached || rchflg)) {
 			sc = ln->tn_sym->s_scl;
 			/*
-			 * Look if there was a asm statement in one of the
+			 * Look if there was an asm statement in one of the
 			 * compound statements we are in. If not, we don't
 			 * print a warning.
 			 */
@@ -3468,8 +3548,6 @@
 	case STRING:
 		return;
 		/* LINTED (enumeration values not handled in switch) */
-	default:
-		break;
 	}
 
 	cvctx = mp->m_vctx;
@@ -3508,7 +3586,7 @@
 /*
  * Checks the range of array indices, if possible.
  * amper is set if only the address of the element is used. This
- * means that the index is allowd to refere to the first element
+ * means that the index is allowd to refer to the first element
  * after the array.
  */
 static void
@@ -3565,7 +3643,7 @@
 }
 
 /*
- * Check for ordered comparisions of unsigned values with 0.
+ * Check for ordered comparisons of unsigned values with 0.
  */
 static void
 chkcomp(op_t op, tnode_t *ln, tnode_t *rn)
@@ -3586,25 +3664,25 @@
 	if ((hflag || pflag) && lt == CHAR && rn->tn_op == CON &&
 	    (rn->tn_val->v_quad < 0 ||
 	     rn->tn_val->v_quad > ~(~0 << (CHAR_BIT - 1)))) {
-		/* nonportable character comparision, op %s */
+		/* nonportable character comparison, op %s */
 		warning(230, mp->m_name);
 		return;
 	}
 	if ((hflag || pflag) && rt == CHAR && ln->tn_op == CON &&
 	    (ln->tn_val->v_quad < 0 ||
 	     ln->tn_val->v_quad > ~(~0 << (CHAR_BIT - 1)))) {
-		/* nonportable character comparision, op %s */
+		/* nonportable character comparison, op %s */
 		warning(230, mp->m_name);
 		return;
 	}
 	if (isutyp(lt) && !isutyp(rt) &&
 	    rn->tn_op == CON && rn->tn_val->v_quad <= 0) {
 		if (rn->tn_val->v_quad < 0) {
-			/* comparision of %s with %s, op %s */
+			/* comparison of %s with %s, op %s */
 			warning(162, tyname(ln->tn_type), "negative constant",
 				mp->m_name);
 		} else if (op == LT || op == GE || (hflag && op == LE)) {
-			/* comparision of %s with %s, op %s */
+			/* comparison of %s with %s, op %s */
 			warning(162, tyname(ln->tn_type), "0", mp->m_name);
 		}
 		return;
@@ -3612,11 +3690,11 @@
 	if (isutyp(rt) && !isutyp(lt) &&
 	    ln->tn_op == CON && ln->tn_val->v_quad <= 0) {
 		if (ln->tn_val->v_quad < 0) {
-			/* comparision of %s with %s, op %s */
+			/* comparison of %s with %s, op %s */
 			warning(162, "negative constant", tyname(rn->tn_type),
 				mp->m_name);
 		} else if (op == GT || op == LE || (hflag && op == GE)) {
-			/* comparision of %s with %s, op %s */
+			/* comparison of %s with %s, op %s */
 			warning(162, "0", tyname(rn->tn_type), mp->m_name);
 		}
 		return;
@@ -3624,7 +3702,7 @@
 }
 
 /*
- * Takes an expression an returns 0 if this expression can be used
+ * Takes an expression and returns 0 if this expression can be used
  * for static initialisation, otherwise -1.
  *
  * Constant initialisation expressions must be costant or an address
@@ -3722,6 +3800,7 @@
 			     (len2 + 1) * sizeof (wchar_t));
 		free(strg2->st_wcp);
 	}
+	strg1->st_len = len;
 	free(strg2);
 
 	return (strg1);
@@ -3738,7 +3817,7 @@
 precconf(tnode_t *tn)
 {
 	tnode_t	*ln, *rn;
-	op_t	lop, rop;
+	op_t	lop, rop = NOOP;
 	int	lparn, rparn;
 	mod_t	*mp;
 	int	warn;
@@ -3799,8 +3878,6 @@
 		}
 		break;
 		/* LINTED (enumeration values not handled in switch) */
-	default:
-		break;
 	}
 
 	if (warn) {
@@ -3809,3 +3886,26 @@
 	}
 
 }
+
+/*
+ * Return the function name of a function (or of a pointer to a
+ * function).
+ */
+const char *
+funcname(tnode_t *tn)
+{
+	/* dereference function pointer */
+	switch (tn->tn_op) {
+	case AMPER:
+		return funcname(tn->tn_left);
+	case LOAD:
+		/* called as (*fptr)(args) */
+		return funcname(tn->tn_left);
+	case CALL:
+		return funcname(tn->tn_left);
+	case NAME:
+		return tn->tn_sym->s_name;
+	default:
+		return "<unknown>";
+	}
+}
Index: usr.bin/xlint/lint2/chk.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint2/chk.c,v
retrieving revision 1.7
diff -u -r1.7 chk.c
--- usr.bin/xlint/lint2/chk.c	7 Jul 2004 12:24:01 -0000	1.7
+++ usr.bin/xlint/lint2/chk.c	25 Dec 2006 10:32:15 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: chk.c,v 1.15 2006/07/09 19:37:00 miod Exp $	*/
 /*	$NetBSD: chk.c,v 1.2 1995/07/03 21:24:42 cgd Exp $	*/
 
 /*
@@ -30,7 +31,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: chk.c,v 1.2 1995/07/03 21:24:42 cgd Exp $
  * $DragonFly: src/usr.bin/xlint/lint2/chk.c,v 1.7 2004/07/07 12:24:01 asmodai Exp $
  */
 
@@ -53,13 +53,11 @@
 static	void	chkvtdi(hte_t *, sym_t *, sym_t *);
 static	void	chkfaui(hte_t *, sym_t *, sym_t *);
 static	void	chkau(hte_t *, int, sym_t *, sym_t *, pos_t *,
-			   fcall_t *, fcall_t *, type_t *, type_t *);
+		   fcall_t *, fcall_t *, type_t *, type_t *);
 static	void	chkrvu(hte_t *, sym_t *);
 static	void	chkadecl(hte_t *, sym_t *, sym_t *);
-static	void	printflike(hte_t *,fcall_t *, int,
-				const char *, type_t **);
-static	void	scanflike(hte_t *, fcall_t *, int,
-			       const char *, type_t **);
+static	void	printflike(hte_t *,fcall_t *, int, const char *, type_t **);
+static	void	scanflike(hte_t *, fcall_t *, int, const char *, type_t **);
 static	void	badfmt(hte_t *, fcall_t *);
 static	void	inconarg(hte_t *, fcall_t *, int);
 static	void	tofewarg(hte_t *, fcall_t *);
@@ -77,73 +75,73 @@
 		tspec_t	it_tspec;
 		ttab_t	it_ttab;
 	} ittab[] = {
-		{ SIGNED,   { 0, 0,
+		{ SIGNED,   { 0, 0, 0,
 				      SIGNED, UNSIGN,
 				      0, 0, 0, 0, 0, "signed" } },
-		{ UNSIGN,   { 0, 0,
+		{ UNSIGN,   { 0, 0, 0,
 				      SIGNED, UNSIGN,
 				      0, 0, 0, 0, 0, "unsigned" } },
-		{ CHAR,	    { CHAR_BIT, CHAR_BIT,
+		{ CHAR,	    { CHAR_BIT, CHAR_BIT, 20,
 				      SCHAR, UCHAR,
 				      1, 0, 0, 1, 1, "char" } },
-		{ SCHAR,    { CHAR_BIT, CHAR_BIT,
+		{ SCHAR,    { CHAR_BIT, CHAR_BIT, 20,
 				      SCHAR, UCHAR,
 				      1, 0, 0, 1, 1, "signed char" } },
-		{ UCHAR,    { CHAR_BIT, CHAR_BIT,
+		{ UCHAR,    { CHAR_BIT, CHAR_BIT, 20,
 				      SCHAR, UCHAR,
 				      1, 1, 0, 1, 1, "unsigned char" } },
-		{ SHORT,    { sizeof (short) * CHAR_BIT, 2 * CHAR_BIT,
+		{ SHORT,    { sizeof (short) * CHAR_BIT, 2 * CHAR_BIT, 30,
 				      SHORT, USHORT,
 				      1, 0, 0, 1, 1, "short" } },
-		{ USHORT,   { sizeof (u_short) * CHAR_BIT, 2 * CHAR_BIT,
+		{ USHORT,   { sizeof (u_short) * CHAR_BIT, 2 * CHAR_BIT, 30,
 				      SHORT, USHORT,
 				      1, 1, 0, 1, 1, "unsigned short" } },
-		{ INT,      { sizeof (int) * CHAR_BIT, 3 * CHAR_BIT,
+		{ INT,      { sizeof (int) * CHAR_BIT, 3 * CHAR_BIT, 40,
 				      INT, UINT,
 				      1, 0, 0, 1, 1, "int" } },
-		{ UINT,     { sizeof (u_int) * CHAR_BIT, 3 * CHAR_BIT,
+		{ UINT,     { sizeof (u_int) * CHAR_BIT, 3 * CHAR_BIT, 40,
 				      INT, UINT,
 				      1, 1, 0, 1, 1, "unsigned int" } },
-		{ LONG,     { sizeof (long) * CHAR_BIT, 4 * CHAR_BIT,
+		{ LONG,     { sizeof (long) * CHAR_BIT, 4 * CHAR_BIT, 50,
 				      LONG, ULONG,
 				      1, 0, 0, 1, 1, "long" } },
-		{ ULONG,    { sizeof (u_long) * CHAR_BIT, 4 * CHAR_BIT,
+		{ ULONG,    { sizeof (u_long) * CHAR_BIT, 4 * CHAR_BIT, 50,
 				      LONG, ULONG,
 				      1, 1, 0, 1, 1, "unsigned long" } },
-		{ QUAD,     { sizeof (quad_t) * CHAR_BIT, 8 * CHAR_BIT,
+		{ QUAD,     { sizeof (quad_t) * CHAR_BIT, 8 * CHAR_BIT, 60,
 				      QUAD, UQUAD,
 				      1, 0, 0, 1, 1, "long long" } },
-		{ UQUAD,    { sizeof (u_quad_t) * CHAR_BIT, 8 * CHAR_BIT,
+		{ UQUAD,    { sizeof (u_quad_t) * CHAR_BIT, 8 * CHAR_BIT, 60,
 				      QUAD, UQUAD,
 				      1, 1, 0, 1, 1, "unsigned long long" } },
-		{ FLOAT,    { sizeof (float) * CHAR_BIT, 4 * CHAR_BIT,
+		{ FLOAT,    { sizeof (float) * CHAR_BIT, 4 * CHAR_BIT, -1,
 				      FLOAT, FLOAT,
 				      0, 0, 1, 1, 1, "float" } },
-		{ DOUBLE,   { sizeof (double) * CHAR_BIT, 8 * CHAR_BIT,
+		{ DOUBLE,   { sizeof (double) * CHAR_BIT, 8 * CHAR_BIT, -1,
 				      DOUBLE, DOUBLE,
 				      0, 0, 1, 1, 1, "double" } },
-		{ LDOUBLE,  { sizeof (ldbl_t) * CHAR_BIT, 10 * CHAR_BIT,
+		{ LDOUBLE,  { sizeof (ldbl_t) * CHAR_BIT, 10 * CHAR_BIT, -1,
 				      LDOUBLE, LDOUBLE,
 				      0, 0, 1, 1, 1, "long double" } },
-		{ VOID,     { -1, -1,
+		{ VOID,     { -1, -1, -1,
 				      VOID, VOID,
 				      0, 0, 0, 0, 0, "void" } },
-		{ STRUCT,   { -1, -1,
+		{ STRUCT,   { -1, -1, -1,
 				      STRUCT, STRUCT,
 				      0, 0, 0, 0, 0, "struct" } },
-		{ UNION,    { -1, -1,
+		{ UNION,    { -1, -1, -1,
 				      UNION, UNION,
 				      0, 0, 0, 0, 0, "union" } },
-		{ ENUM,     { sizeof (int) * CHAR_BIT, 3 * CHAR_BIT,
+		{ ENUM,     { sizeof (int) * CHAR_BIT, 3 * CHAR_BIT, 40,
 				      ENUM, ENUM,
 				      1, 0, 0, 1, 1, "enum" } },
-		{ PTR,      { sizeof (void *) * CHAR_BIT, 4 * CHAR_BIT,
+		{ PTR,      { sizeof (void *) * CHAR_BIT, 4 * CHAR_BIT, -1,
 				      PTR, PTR,
 				      0, 1, 0, 0, 1, "pointer" } },
-		{ ARRAY,    { -1, -1,
+		{ ARRAY,    { -1, -1, -1,
 				      ARRAY, ARRAY,
 				      0, 0, 0, 0, 0, "array" } },
-		{ FUNC,     { -1, -1,
+		{ FUNC,     { -1, -1, -1,
 				      FUNC, FUNC,
 				      0, 0, 0, 0, 0, "function" } },
 	};
@@ -227,11 +225,11 @@
 		return;
 
 	if ((fcall = hte->h_calls) != NULL) {
-		/* %s used( %s ), but not defined */
-		msg(0, hte->h_name, mkpos(&fcall->f_pos));
+		/* %s: %s used, but not defined */
+		msg(0, mkpos(&fcall->f_pos), hte->h_name);
 	} else if ((usym = hte->h_usyms) != NULL) {
-		/* %s used( %s ), but not defined */
-		msg(0, hte->h_name, mkpos(&usym->u_pos));
+		/* %s: %s used, but not defined */
+		msg(0, mkpos(&usym->u_pos), hte->h_name);
 	}
 }
 
@@ -248,8 +246,8 @@
 
 	for (sym = hte->h_syms; sym != NULL; sym = sym->s_nxt) {
 		if (sym->s_def == DEF || sym->s_def == TDEF) {
-			/* %s defined( %s ), but never used */
-			msg(1, hte->h_name, mkpos(&sym->s_pos));
+			/* %s: %s defined, but never used */
+			msg(1, mkpos(&sym->s_pos), hte->h_name);
 			break;
 		}
 	}
@@ -270,13 +268,19 @@
 	if ((sym = hte->h_syms) != NULL) {
 		if (sym->s_def != DECL)
 			errx(1, "internal error: chkdnud() 1");
-		/* %s declared( %s ), but never used or defined */
-		msg(2, hte->h_name, mkpos(&sym->s_pos));
+
+		/* don't warn if the name was declared in a separate header */
+		if (sym->s_pos.p_src != sym->s_pos.p_isrc) {
+			return;
+		}
+
+		/* %s: %s declared, but never used or defined */
+		msg(2, mkpos(&sym->s_pos), hte->h_name);
 	}
 }
 
 /*
- * Print a warning if there is more then one definition for
+ * Print a warning if there is more than one definition for
  * this name.
  */
 static void
@@ -301,8 +305,8 @@
 			continue;
 		}
 		pos1 = xstrdup(mkpos(&def1->s_pos));
-		/* %s multiply defined\t%s  ::  %s */
-		msg(3, hte->h_name, pos1, mkpos(&sym->s_pos));
+		/* %s: %s multiply defined (%s) */
+		msg(3, pos1, hte->h_name, mkpos(&sym->s_pos));
 		free(pos1);
 	}
 }
@@ -356,17 +360,17 @@
 				 * accepted for now.
 				 */
 				pos1 = xstrdup(mkpos(&def->s_pos));
-				/* %s value must be decl. before use %s :: %s */
-				msg(17, hte->h_name,
-				    pos1, mkpos(&call->f_pos));
+				/* %s: %s must be decl. before use (%s) */
+				msg(17, pos1, hte->h_name,
+				    mkpos(&call->f_pos));
 				free(pos1);
 			}
 			continue;
 		}
 		if (!eq || (sflag && warn)) {
 			pos1 = xstrdup(mkpos(&def->s_pos));
-			/* %s value used inconsistenty\t%s  ::  %s */
-			msg(4, hte->h_name, pos1, mkpos(&call->f_pos));
+			/* %s: %s used inconsistently (%s) */
+			msg(4, pos1, hte->h_name, mkpos(&call->f_pos));
 			free(pos1);
 		}
 	}
@@ -404,8 +408,8 @@
 		}
 		if (!eq || (sflag && warn)) {
 			pos1 = xstrdup(mkpos(&def->s_pos));
-			/* %s value declared inconsistently\t%s  ::  %s */
-			msg(5, hte->h_name, pos1, mkpos(&sym->s_pos));
+			/* %s: %s declared inconsistently (%s) */
+			msg(5, pos1, hte->h_name, mkpos(&sym->s_pos));
 			free(pos1);
 		}
 	}
@@ -430,7 +434,7 @@
 		return;
 
 	/*
-	 * If we find a function definition, we use this for comparision,
+	 * If we find a function definition, we use this for comparison,
 	 * otherwise the first prototype we can find. If there is no
 	 * definition or prototype declaration, the first function call
 	 * is used.
@@ -486,8 +490,8 @@
 			 */
 		} else {
 			pos1 = xstrdup(mkpos(pos1p));
-			/* %s: variable # of args\t%s  ::  %s */
-			msg(7, hte->h_name, pos1, mkpos(&call->f_pos));
+			/* %s: %s called with varying # of args (%s) */
+			msg(7, pos1, hte->h_name, mkpos(&call->f_pos));
 			free(pos1);
 			continue;
 		}
@@ -526,7 +530,7 @@
  */
 static void
 chkau(hte_t *hte, int n, sym_t *def, sym_t *decl, pos_t *pos1p,
-      fcall_t *call1, fcall_t *call, type_t *arg1, type_t *arg2)
+    fcall_t *call1, fcall_t *call, type_t *arg1, type_t *arg2)
 {
 	/* LINTED (automatic hides external declaration: warn) */
 	int	promote, asgn, warn;
@@ -589,12 +593,12 @@
 			} else if (t1 == CHAR || t1 == SCHAR) {
 				t1 = INT;
 			} else if (t1 == UCHAR) {
-				t1 = tflag ? UINT : INT;
+				t1 = INT;
 			} else if (t1 == SHORT) {
 				t1 = INT;
 			} else if (t1 == USHORT) {
 				/* CONSTCOND */
-				t1 = INT_MAX < USHRT_MAX || tflag ? UINT : INT;
+				t1 = INT_MAX < USHRT_MAX ? UINT : INT;
 			}
 		}
 
@@ -663,8 +667,8 @@
 	}
 
 	pos1 = xstrdup(mkpos(pos1p));
-	/* %s, arg %d used inconsistently\t%s  ::  %s */
-	msg(6, hte->h_name, n, pos1, mkpos(&call->f_pos));
+	/* %s: %s arg %d used inconsistently (%s) */
+	msg(6, pos1, hte->h_name, n, mkpos(&call->f_pos));
 	free(pos1);
 }
 
@@ -678,7 +682,7 @@
 	const	char *fp;
 	int	fc;
 	int	fwidth, prec, left, sign, space, alt, zero;
-	tspec_t	sz, t1, t2;
+	tspec_t	sz, t1, t2 = NOTSPEC;
 	type_t	*tp;
 
 	fp = fmt;
@@ -836,8 +840,8 @@
 					inconarg(hte, call, n);
 			}
 		} else if (fc == 'D' || fc == 'O' || fc == 'U') {
-			if ((alt && fc != 'O') || sz != NOTSPEC || !tflag)
-				badfmt(hte, call);
+			/* DOU are deprecated */
+			badfmt(hte, call);
 			sz = LONG;
 			if (fc == 'D') {
 				goto int_conv;
@@ -903,7 +907,7 @@
 	const	char *fp;
 	int	fc;
 	int	noasgn, fwidth;
-	tspec_t	sz, t1, t2;
+	tspec_t	sz, t1 = NOTSPEC, t2 = NOTSPEC;
 	type_t	*tp;
 
 	fp = fmt;
@@ -994,13 +998,11 @@
 			}
 			goto conv;
 		} else if (fc == 'D') {
-			if (sz != NOTSPEC || !tflag)
-				badfmt(hte, call);
+			badfmt(hte, call);
 			sz = LONG;
 			goto conv;
 		} else if (fc == 'O') {
-			if (sz != NOTSPEC || !tflag)
-				badfmt(hte, call);
+			badfmt(hte, call);
 			sz = ULONG;
 			goto conv;
 		} else if (fc == 'X') {
@@ -1008,8 +1010,7 @@
 			 * XXX valid in ANSI C, but in NetBSD's libc imple-
 			 * mented as "lx". Thats why it should be avoided.
 			 */
-			if (sz != NOTSPEC || !tflag)
-				badfmt(hte, call);
+			badfmt(hte, call);
 			sz = ULONG;
 			goto conv;
 		} else if (fc == 'E') {
@@ -1017,14 +1018,12 @@
 			 * XXX valid in ANSI C, but in NetBSD's libc imple-
 			 * mented as "lf". Thats why it should be avoided.
 			 */
-			if (sz != NOTSPEC || !tflag)
-				badfmt(hte, call);
+			badfmt(hte, call);
 			sz = DOUBLE;
 			goto conv;
 		} else if (fc == 'F') {
 			/* XXX only for backward compatibility */
-			if (sz != NOTSPEC || !tflag)
-				badfmt(hte, call);
+			badfmt(hte, call);
 			sz = DOUBLE;
 			goto conv;
 		} else if (fc == 'G') {
@@ -1091,29 +1090,29 @@
 static void
 badfmt(hte_t *hte, fcall_t *call)
 {
-	/* %s: malformed format string\t%s */
-	msg(13, hte->h_name, mkpos(&call->f_pos));
+	/* %s: malformed format string argument to %s */
+	msg(13, mkpos(&call->f_pos), hte->h_name);
 }
 
 static void
 inconarg(hte_t *hte, fcall_t *call, int n)
 {
-	/* %s, arg %d inconsistent with format\t%s(%d) */
-	msg(14, hte->h_name, n, mkpos(&call->f_pos));
+	/* %s: arg %d to %s is inconsistent with format */
+	msg(14, mkpos(&call->f_pos), n, hte->h_name);
 }
 
 static void
 tofewarg(hte_t *hte, fcall_t *call)
 {
-	/* %s: too few args for format  \t%s */
-	msg(15, hte->h_name, mkpos(&call->f_pos));
+	/* %s: too few format args to %s */
+	msg(15, mkpos(&call->f_pos), hte->h_name);
 }
 
 static void
 tomanyarg(hte_t *hte, fcall_t *call)
 {
-	/* %s: too many args for format  \t%s */
-	msg(16, hte->h_name, mkpos(&call->f_pos));
+	/* %s: too many format args to %s */
+	msg(16, mkpos(&call->f_pos), hte->h_name);
 }
 
 
@@ -1138,7 +1137,7 @@
 		/* function has return value */
 		used = ignored = 0;
 		for (call = hte->h_calls; call != NULL; call = call->f_nxt) {
-			used |= call->f_rused;
+			used |= call->f_rused || call->f_rdisc;
 			ignored |= !call->f_rused && !call->f_rdisc;
 		}
 		/*
@@ -1160,8 +1159,8 @@
 		/* function has no return value */
 		for (call = hte->h_calls; call != NULL; call = call->f_nxt) {
 			if (call->f_rused)
-				/* %s value is used( %s ), but none ret. */
-				msg(10, hte->h_name, mkpos(&call->f_pos));
+				/* %s: return value of %s is used, but none ret. */
+				msg(10, mkpos(&call->f_pos), hte->h_name);
 		}
 	}
 }
@@ -1208,8 +1207,8 @@
 			if (!eq || warn) {
 				pos1 = xstrdup(mkpos(&sym1->s_pos));
 				pos2 = mkpos(&sym->s_pos);
-				/* %s, arg %d declared inconsistently ... */
-				msg(11, hte->h_name, n + 1, pos1, pos2);
+				/* %s: %s arg %d declared inconsistently ... */
+				msg(11, pos1, hte->h_name, n + 1, pos2);
 				free(pos1);
 			}
 			n++;
@@ -1226,9 +1225,9 @@
 				continue;
 			}
 		}
-		/* %s: variable # of args declared\t%s  ::  %s */
+		/* %s: %s declared with varying # of args (%s) */
 		pos1 = xstrdup(mkpos(&sym1->s_pos));
-		msg(12, hte->h_name, pos1, mkpos(&sym->s_pos));
+		msg(12, pos1, hte->h_name, mkpos(&sym->s_pos));
 		free(pos1);
 	}
 }
@@ -1240,8 +1239,8 @@
  *
  * ignqual	if set, ignore qualifiers of outhermost type; used for
  *		function arguments
- * promote	if set, promote left type before comparision; used for
- *		comparisions of arguments with parameters of old style
+ * promote	if set, promote left type before comparison; used for
+ *		comparisons of arguments with parameters of old style
  *		definitions
  * asgn		left indirected type must have at least the same qualifiers
  *		like right indirected type (for assignments and function
@@ -1267,12 +1266,12 @@
 			} else if (t == CHAR || t == SCHAR) {
 				t = INT;
 			} else if (t == UCHAR) {
-				t = tflag ? UINT : INT;
+				t = INT;
 			} else if (t == SHORT) {
 				t = INT;
 			} else if (t == USHORT) {
 				/* CONSTCOND */
-				t = INT_MAX < USHRT_MAX || tflag ? UINT : INT;
+				t = INT_MAX < USHRT_MAX ? UINT : INT;
 			}
 		}
 
@@ -1312,7 +1311,7 @@
 				return (0);
 			if (!tp1->t_volatile && tp2->t_volatile)
 				return (0);
-		} else if (!ignqual && !tflag) {
+		} else if (!ignqual) {
 			if (tp1->t_const != tp2->t_const)
 				return (0);
 			if (tp1->t_const != tp2->t_const)
